;Program: Notepad 82 ASM V3.0
;Name: Adam Milecki (TideGear@aol.com)
;    : Carlos Braga (lacasitos@hotmail.com)
;Date: 9/8/2003

 #include "crash82.inc"
 .db "Notepad",0     

 ROM_CALL(CLEARLCD)      

enterText:           
 
 ld hl,text
 ld (hl),'>'      
 ld c,0
    
_txtEnter:              
 push hl
 ld hl,0
 ld (CURSOR_POS),hl
 ld hl,text
 ROM_CALL(D_ZT_STR)

_keyPress:
 push bc
 call GET_KEY
 pop bc
 pop hl
 inc hl
 ld (hl),0
 dec hl
 cp G_YEDIT
 jp z,_charAt
 cp G_WINDOW
 jp z,_charBk
 cp G_ZOOM
 jp z,_charUp
 cp G_TRACE
 jp z,_charFr
 cp G_GRAPH
 jp z,_charDn
 cp G_STAT
 jp z,_charEq
 cp G_PERIOD
 jp z,_charPeriod
 cp G_MATH
 jp z,_charA
 cp G_MATRIX
 jp z,_charB
 cp G_PRGM
 jp z,_charC
 cp G_INVE
 jp z,_charD
 cp G_SIN
 jp z,_charE
 cp G_COS
 jp z,_charF
 cp G_TAN
 jp z,_charG
 cp G_CARROT
 jp z,_charH
 cp G_SQR
 jp z,_charI
 cp G_COMMA
 jp z,_charJ
 cp G_PARENL
 jp z,_charK
 cp G_PARENR
 jp z,_charL
 cp G_DIV
 jp z,_charM
 cp G_LOG
 jp z,_charN
 cp G_7
 jp z,_charO
 cp G_8
 jp z,_charP
 cp G_9
 jp z,_charQ
 cp G_TIMES
 jp z,_charR
 cp G_LN
 jp z,_charS 
 cp G_4
 jp z,_charT
 cp G_5
 jp z,_charU
 cp G_6
 jp z,_charV
 cp G_MINUS
 jp z,_charW
 cp G_STO
 jp z,_charX
 cp G_1
 jp z,_charY
 cp G_2
 jp z,_charZ
 cp G_NEG
 jp z,_charMinus
 cp G_0
 jp z,_charSpace
 cp G_DEL
 jp z,_backspace
 cp G_ENTER
 jp z,_Quit
 cp G_ALPHA
 jp z,_NumlockTE
 cp G_2ND
 jp z,_CapslockTE
 jp _txtEnter

_Numlock
 push bc
 call GET_KEY
 pop bc
 pop hl
 inc hl
 ld (hl),0
 dec hl
 cp G_STAT
 jp z,_charEql
 cp G_7
 jp z,_char7
 cp G_8
 jp z,_char8
 cp G_9
 jp z,_char9
 cp G_4
 jp z,_char4
 cp G_5
 jp z,_char5
 cp G_6
 jp z,_char6
 cp G_1
 jp z,_char1
 cp G_2
 jp z,_char2
 cp G_3
 jp z,_char3
 cp G_0
 jp z,_char0
 cp G_MINUS
 jp z,_charMinusl
 cp G_PLUS
 jp z,_charPlus
 cp G_TIMES
 jp z,_charTimes
 cp G_DIV
 jp z,_charDiv
 cp G_CARROT
 jp z,_charCarr
 cp G_PERIOD
 jp z,_charPeriodl 
 cp G_NEG
 jp z,_charNeg
 cp G_0
 jp z,_charSpacel
 cp G_DEL
 jp z,_backspacel
 cp G_ENTER
 jp z,_Quit
 cp G_2ND
 jp z,_CapslockTE
 cp G_ALPHA
 jp z,_txtEnter
 jp z,_NumlockTE

_NumlockTE:
 push hl
 ld hl,0
 ld (CURSOR_POS),hl
 ld hl,text
 ROM_CALL(D_ZT_STR)
 jp _Numlock

_Capslock
 push bc
 call GET_KEY
 pop bc
 pop hl
 inc hl
 ld (hl),0
 dec hl
 cp G_NEG
 jp z,_charMinusc
 cp G_YEDIT
 jp z,_charAtc
 cp G_WINDOW
 jp z,_charBkc
 cp G_ZOOM
 jp z,_charUpc
 cp G_TRACE
 jp z,_charFrc
 cp G_GRAPH
 jp z,_charDnc
 cp G_STAT
 jp z,_charEqc
 cp G_PERIOD
 jp z,_charPeriodc
 cp G_MATH
 jp z,_charAc
 cp G_MATRIX
 jp z,_charBc
 cp G_PRGM
 jp z,_charCc
 cp G_INVE
 jp z,_charDc
 cp G_SIN
 jp z,_charEc
 cp G_COS
 jp z,_charFc
 cp G_TAN
 jp z,_charGc
 cp G_CARROT
 jp z,_charHc
 cp G_SQR
 jp z,_charIc
 cp G_COMMA
 jp z,_charJc
 cp G_PARENL
 jp z,_charKc
 cp G_PARENR
 jp z,_charLc
 cp G_DIV
 jp z,_charMc
 cp G_LOG
 jp z,_charNc
 cp G_7
 jp z,_charOc
 cp G_8
 jp z,_charPc
 cp G_9
 jp z,_charQc
 cp G_TIMES
 jp z,_charRc
 cp G_LN
 jp z,_charSc 
 cp G_4
 jp z,_charTc
 cp G_5
 jp z,_charUc
 cp G_6
 jp z,_charVc
 cp G_MINUS
 jp z,_charWc
 cp G_STO
 jp z,_charXc
 cp G_1
 jp z,_charYc
 cp G_2
 jp z,_charZc
 cp G_0
 jp z,_charSpacec
 cp G_DEL
 jp z,_backspacec
 cp G_ENTER
 jp z,_Quit
 cp G_ALPHA
 jp z,_NumlockTE
 cp G_2ND
 jp z,_txtEnter
 jp _CapslockTE

_CapslockTE
 push hl
 ld hl,0
 ld (CURSOR_POS),hl
 ld hl,text
 ROM_CALL(D_ZT_STR)
 jp _Capslock

_Quit:
 ld a,c
 inc hl
 inc c
 ld (hl),' '
 ret 

_charMinusl:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'-'
 jp _NumlockTE

_charSpace:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),' '
 jp _txtEnter

_charPeriodc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'.'
 jp _CapslockTE

_charSpacel:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),' '
 jp _NumlockTE

_charPeriodl:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'.'
 jp _NumlockTE

_charEql:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'='
 jp _NumlockTE

_charMinusc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'-'
 jp _CapslockTE

_charSpacec:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),' '
 jp _CapslockTE

_char0
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'0'
 jp _NumlockTE

_char1
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'1'
 jp _NumlockTE

_char2
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'2'
 jp _NumlockTE

_char3
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'3'
 jp _NumlockTE

_char4
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'4'
 jp _NumlockTE

_char5
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'5'
 jp _NumlockTE

_char6
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'6'
 jp _NumlockTE

_char7
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'7'
 jp _NumlockTE

_char8
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'8'
 jp _NumlockTE

_char9
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'9'
 jp _NumlockTE

_charPeriod:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'.'
 jp _txtEnter

_charPlus
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'+'
 jp _NumlockTE

_charMinus
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'-'
 jp _NumlockTE

_charTimes
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'*'
 jp _NumlockTE

_charDiv
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'/'
 jp _NumlockTE

_charCarr
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'^'
 jp _NumlockTE

_charNeg
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'~'
 jp _NumlockTE

_charA:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'a'
 jp _txtEnter

_charB:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'b'
 jp _txtEnter

_charC:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'c'
 jp _txtEnter

_charD:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'d'
 jp _txtEnter

_charE:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'e'
 jp _txtEnter

_charF:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'f'
 jp _txtEnter

_charG:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'g'
 jp _txtEnter

_charH:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'h'
 jp _txtEnter

_charI:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'i'
 jp _txtEnter

_charJ:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'j'
 jp _txtEnter

_charK:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'k'
 jp _txtEnter

_charL:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'l'
 jp _txtEnter

_charM:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'m'
 jp _txtEnter

_charN:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'n'
 jp _txtEnter

_charO:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'o'
 jp _txtEnter

_charP:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'p'
 jp _txtEnter

_charQ:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'q'
 jp _txtEnter

_charR:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'r'
 jp _txtEnter

_charS:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'s'
 jp _txtEnter

_charT:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'t'
 jp _txtEnter

_charU:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'u'
 jp _txtEnter

_charV:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'v'
 jp _txtEnter

_charW:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'w'
 jp _txtEnter

_charY:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'y'
 jp _txtEnter

_charX:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'x'
 jp _txtEnter

_charZ:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'z'
 jp _txtEnter

_charAt:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'@'
 jp _txtEnter

_charFr:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),$3E
 jp _txtEnter

_charBk:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),$3C
 jp _txtEnter

_charDn:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),$1F
 jp _txtEnter

_charUp:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),$1E
 jp _txtEnter

_charEq:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),$3D
 jp _txtEnter

_charAc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'A'
 jp _CapslockTE

_charBc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'B'
 jp _CapslockTE

_charCc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'C'
 jp _CapslockTE

_charDc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'D'
 jp _CapslockTE

_charEc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'E'
 jp _CapslockTE

_charFc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'F'
 jp _CapslockTE

_charGc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'G'
 jp _CapslockTE

_charHc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'H'
 jp _CapslockTE

_charIc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'I'
 jp _CapslockTE

_charJc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'J'
 jp _CapslockTE

_charKc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'K'
 jp _CapslockTE

_charLc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'L'
 jp _CapslockTE

_charMc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'M'
 jp _CapslockTE

_charNc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'N'
 jp _CapslockTE

_charOc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'O'
 jp _CapslockTE

_charPc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'P'
 jp _CapslockTE

_charQc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'Q'
 jp _CapslockTE

_charRc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'R'
 jp _CapslockTE

_charSc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'S'
 jp _CapslockTE

_charTc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'T'
 jp _CapslockTE

_charUc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'U'
 jp _CapslockTE

_charVc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'V'
 jp _CapslockTE

_charWc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'W'
 jp _CapslockTE

_charYc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'Y'
 jp _CapslockTE

_charXc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'X'
 jp _CapslockTE

_charZc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'Z'
 jp _CapslockTE

_charAtc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'@'
 jp _CapslockTE

_charFrc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),$05
 jp _CapslockTE

_charBkc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),$CF
 jp _CapslockTE

_charDnc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),$07
 jp _CapslockTE

_charUpc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),$06
 jp _CapslockTE

_charEqc:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),$7F
 jp _CapslockTE

_backspacel:
 ld a,c
 or a
 jp z,_noBckspcel
 ld (hl),' '
 dec hl
 dec c
_noBckspcel:
 jp _NumlockTE

_saveLetter:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'A'
_noSaveLtr:
 jp _txtEnter

_backspacec:
 ld a,c
 or a
 jp z,_noBckspcec
 ld (hl),' '
 dec hl
 dec c
_noBckspcec:
 jp _CapslockTE

_backspace:
 ld a,c
 or a
 jp z,_noBckspce
 ld (hl),' '
 dec hl
 dec c
_noBckspce:
 jp _txtEnter

_saveLetterc:
 ld a,c
 cp 124
 jp z,_noSaveLtrc
 inc hl
 inc c
 ld (hl),'A'
_noSaveLtrc:
 jp _CapslockTE

text:
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

 .end
